#include	"archi.h"
#include	"ChunkHeader.h"

#include	<iostream>



long	ChunkHeader::get_len ()
{
	return (8);
}



int	ChunkHeader::read (std::istream &is)
{
	int		res = 0;

	res |= int (! is.read (_id, sizeof (_id)));
	res |= read_le (is, _size);
	_pos = is.tellg ();
	res |= int (! is);

	if (res != 0)
	{
		return (-1);
	}

	return (0);
}



int	ChunkHeader::write (std::ostream &os) const
{
	int		res = 0;

	res |= int (! os.write (_id, sizeof (_id)));
	res |= write_le (os, _size);
	_pos = os.tellp ();
	res |= int (! os);

	if (res != 0)
	{
		return (-1);
	}

	return (0);
}



int	ChunkHeader::skip (std::istream &is) const
{
	using namespace std;

	streampos	new_pos (_pos);
	new_pos += _size;

	if (! is.seekg (new_pos))
	{
		return (-1);
	}

	return (0);
}



int	ChunkHeader::skip (std::ostream &os) const
{
	using namespace std;

	streampos	new_pos (_pos);
	new_pos += _size;

	if (! os.seekp (new_pos))
	{
		return (-1);
	}

	return (0);
}



void	ChunkHeader::set (const char id_0 [4+1])
{
	for (int i = 0; i < 4; ++i)
	{
		_id [i] = id_0 [i];
	}
}



bool	ChunkHeader::cmp (const char *id_0) const
{
	for (int i = 0; i < 4; ++i)
	{
		if (id_0 [i] != _id [i])
		{
			return (false);
		}
	}

	return (true);
}
