#if ! defined (archi_HEADER_INCLUDED)
#define archi_HEADER_INCLUDED



#include	<iostream>

#include	<climits>



#if (CHAR_BIT != 8)
#error char: not a 8-bit type
#endif

#if (INT_MAX == 0x7FFFFFFFL)
typedef	signed	int		Int32;
typedef	unsigned	int		UInt32;
#else
#error Int32: to be implemented
#endif

#if (SHRT_MAX == 0x7FFFL)
typedef	signed	short		Int16;
typedef	unsigned	short		UInt16;
#else
#error Int16: to be implemented
#endif



template <typename T>
int	read_le (std::istream &is, T &val);

template <typename T>
int	write_le (std::ostream &os, const T &val);



////////////////////////////////////////////////////////////////



template <typename T>
int	read_le (std::istream &is, T &val)
{
	using namespace std;

	streambuf *	in_ptr = is.rdbuf ();

	if (in_ptr == NULL)
	{
		is.setstate (ios::badbit);
		return (-1);
	}

	const int	eof = istream::traits_type::eof ();
	val = 0;

	for (int i = 0; i < sizeof (val); ++i)
	{
		int	tmp (in_ptr->sbumpc ());

		if (tmp == eof)
		{
			is.setstate (ios::failbit);
			return (-1);
		}
		else
		{
			val |= T (tmp) << (i * CHAR_BIT);
		}
	}

	return (0);
}



template <typename T>
int	write_le (std::ostream &os, const T &val)
{
	using namespace std;

	streambuf *	out_ptr = os.rdbuf ();

	if (out_ptr == NULL)
	{
		os.setstate (ios::badbit);
		return (-1);
	}

	const int	eof = istream::traits_type::eof ();

	for (int i = 0; i < sizeof (val); ++i)
	{
		char	tmp (val >> (i * CHAR_BIT));

		if (out_ptr->sputc (tmp) == eof)
		{
			os.setstate (ios::failbit);
			return (-1);
		}
	}

	return (0);
}



#endif